//cl65 -O -Cl -t atari -Wl -D__SYSTEM_CHECK__=1,-D__RESERVED_MEMORY__=1 arpeggiator3.c -o arpeggiator3.com
#include <unistd.h>
#include "pokey.h"

#define PUTS(str) write(STDOUT_FILENO, str, sizeof str - 1)

void wait1(void)
{
    __asm__("lda $14");
    __asm__("wait: cmp $14");
    __asm__("beq wait");
}

#define AMP_LFO_SIZE 18
typedef struct
{
    byte amp[AMP_LFO_SIZE];
} AmpLFO;

#define PITCH_LFO_SIZE 16
#define PITCH_LFO_STEP 6
typedef struct
{
    byte transpose[PITCH_LFO_SIZE];
} PitchLFO;

const AmpLFO amp_lfo1 = {{3,3,4,5,6,7,8,9,11,12,10,9,7,6,5,5,4,4}};
const AmpLFO amp_lfo2 = {{10,6,4,3,2,2,10,6,4,3,2,2,10,6,4,3,2,2}};
const PitchLFO pitch_lfo = {{7,0,7,0,4,0,6,0,2,0,4,0,2,0,4,0}};
const byte f[] = {254,226,213,190,169,160,142,127,113,106,95,84};

void pattern(const byte root, const byte steps)
{
    byte i = 0, j, k, m = 0, n;
    for (k = steps; k > 0; --k)
    {
        n = pitch_lfo.transpose[m] + root;
        P0.audf2 = f[n];
        P0.audf4 = f[n] + 1;

        ++m;
        if (m == PITCH_LFO_SIZE)
            m = 0;

        for (j = PITCH_LFO_STEP; j > 0; --j)
        {
            P0.audc2 = 0xa0 | amp_lfo1.amp[i];
            P0.audc4 = 0xa0 | amp_lfo2.amp[i];

            ++i;
            if (i == AMP_LFO_SIZE)
                i = 0;

            wait1();
        }
    }
}

int main(void)
{
    PUTS("arpeggiator3/2018-08-17\n");
    P0.skctl = 3;
    P0.audctl = 2;
    for (;;)
    {
        pattern(0, 64);
        pattern(3, 32);
        pattern(0, 32);
        pattern(4, 16);
        pattern(3, 16);
        pattern(0, 32);
        pattern(4, 8);
        pattern(3, 8);
        pattern(0, 8);
        pattern(0, 8);
        pattern(4, 8);
        pattern(3, 8);
        pattern(0, 8);
    }
}
