
        icl 'antic.inc'
        icl 'pokey.inc'
        icl 'os.inc'

        org $3000

title   dta c"memories-of-the-future/2018-03-10",eol

init
        ldx #<title
        ldy #>title
        jsr print

        lda rtclock+2
        cmp rtclock+2
        beq *-2

        sei
        lda #0
        sta skctl
        lda #32+64
        sta audctl
        lda #1
        sta audf1
        sta audf3
        lda #3
        sta wsync
        sta skctl
        sta stimer
        lda #2
        sta audf1
        sta audf3
        cli

track_position equ $80
env1_position equ $81
env2_position equ $82

        mva #3*9 env1_position

step0
        ldy #256-track_size
step
        sty track_position
        ldx track-256+track_size,y
        beq play
        tya
        ldy #0
        and #1
        beq even
        stx audf3
        sty env1_position
        bne play
even
        stx audf1
        sty env2_position
play
        ldx #9
play_
        ldy env1_position
        lda env,y
        sta audc3
        inc env1_position

        ldy env2_position
        lda env,y
        sta audc1
        inc env2_position

next
        lda rtclock+2
        cmp rtclock+2
        beq *-2

        dex
        bne play_
        ldy track_position
        iny
        bne step
        beq step0

_       equ 0

env     
        dta $c3,$c5,$c6,$c5,$c4,$c4,$c3,$c3,$c3,$c3,$c2,$c2,$c2,$c2,$c2,$c2,$c2,$c2,$c2,$c2,$c2
        dta $c2,$c1,$c1,$c1,$c1,$c1,$c1,$c1,$c1,$c0,$c0,$c0,$c0,$c0,$c0

track
        dta 128,137,155,209,155,137,233,155,137,128,137,155,_,209,155,137,209,128,113,209,128,209,137,209

track_size equ *-track

        icl 'print.asm'

        run init

