//cl65 -O -Cl -t atari -Wl -D__SYSTEM_CHECK__=1,-D__RESERVED_MEMORY__=1 nature.c -o nature.com
#include <unistd.h>
#include "pokey.h"

#define PUTS(str) write(STDOUT_FILENO, str, sizeof str - 1)

void wait1(void)
{
    __asm__("lda $14");
    __asm__("wait: cmp $14");
    __asm__("beq wait");
}

#define ENV_SIZE 16
typedef struct
{
    byte amp[ENV_SIZE];
    byte loop_begin;
    byte loop_end;
} Envelope;

typedef struct
{
    byte i;
} EnvGenerator;

byte next(EnvGenerator* g, const Envelope* env)
{
    const byte a = env->amp[g->i];

    if (g->i < env->loop_end)
        ++g->i;
    else
        g->i = env->loop_begin;

    return a;
}

void note_on(EnvGenerator* g)
{
    g->i = 0;
}

EnvGenerator gen1 = {0};
EnvGenerator gen2 = {0};
EnvGenerator gen3 = {0};
EnvGenerator gen4 = {0};

const Envelope env1 = {{3,5,4,4,3,3,2,2,2,2,2,2,2,1,1,1}, 2, 15};
const Envelope env2 = {{2,3,4,4,3,3,2,2,2,2,2,2,2,1,1,1}, 2, 14};

#define SCALE_SIZE 13
//                           G3   D4   G4   A4  Bb4  C5  C#5   D5 Eb5   E5   G5   A5  Bb5
const byte f1[SCALE_SIZE] = {78, 150, 171, 188, 219, 55, 116, 192, 27, 118, 210, 211, 106};
const byte f2[SCALE_SIZE] = {35,  23,  17,  15,  14, 13,  12,  11, 11,  10,   8,   7,   7};

#define TRACK_SIZE (2 * 32 + 3)
const byte track[TRACK_SIZE] =
{
    2,7,10,12,2,7,10,12,3,6,9,11,3,6,9,11,2,5,8,10,2,5,8,10,2,7,10,12,11,10,7,4,
    2,7,10,12,2,7,10,12,3,6,9,11,3,6,9,11,2,5,8,10,2,5,8,10,2,7,10,12,11,10,7,4,
    2,1,0
};

int main(void)
{
    byte i, j, n, step;
    PUTS("intact-nature/2017-10-23\n");

    P0.skctl = 3;
    P0.audctl = 64 + 32 + 16 + 8;
    i = j = 0;
    step = 17;
    for (;;)
    {
        if (j == 0)
        {
            j = step;
            n = track[i];
            if (i & 1)
            {
                note_on(&gen1);
                note_on(&gen2);
                P0.audf1 = f1[n];
                P0.audf2 = f2[n];
            }
            else
            {
                note_on(&gen3);
                note_on(&gen4);
                P0.audf3 = f1[n];
                P0.audf4 = f2[n];
            }

            if (i >= 28 + 32)
                step += 3;
            if (i == TRACK_SIZE - 2)
                step = 85;

            ++i;
            if (i == TRACK_SIZE)
            {
                i = 0;
                step = 17;
            }
        }

        P0.audc1 = 0xc0 | next(&gen1, &env1);
        P0.audc2 = 0xa0 | next(&gen2, &env2);
        P0.audc3 = 0xc0 | next(&gen3, &env1);
        P0.audc4 = 0xa0 | next(&gen4, &env2);
        --j;
        wait1();
    }
}
