//cl65 -O -Cl -t atari -Wl -D__SYSTEM_CHECK__=1,-D__RESERVED_MEMORY__=1 ostatnie-podrygi.c -o ostatnie-podrygi.com
#include <unistd.h>
#include "pokey.h"

#define PUTS(str) write(STDOUT_FILENO, str, sizeof str - 1)

void wait1(void)
{
    __asm__("lda $14");
    __asm__("wait: cmp $14");
    __asm__("beq wait");
}

#define ENV_SIZE 20
typedef struct
{
    byte amp[ENV_SIZE];
} Envelope;

typedef struct
{
    byte i;
    byte on;
} EnvGenerator;

byte next(EnvGenerator* g, const Envelope* env)
{
    const byte a = env->amp[g->i];

    if (!g->on && g->i < ENV_SIZE - 1)
        ++g->i;

    return a;
}

void note_on(EnvGenerator* g)
{
    g->i = 0;
    g->on = 1;
}

void note_off(EnvGenerator* g)
{
    g->on = 0;
}

EnvGenerator gen1 = {ENV_SIZE - 1, 0};
EnvGenerator gen2 = {ENV_SIZE - 1, 0};

const Envelope env = {{7,4,3,3,3,3,3,2,2,2,2,1,1,1,1,1,1,1,1}};

//                 Bb1  Bb2  Db3  Eb3  F3  G3 Ab3
const byte f1[] = {207, 228, 150, 105, 65, 29, 12};
const byte f2[] = {  3,   1,   1,   1,  1,  1,  1};

#define _ (-1)
#define TRACK_SIZE (sizeof track1)
const byte track1[] = {0,_,_,_,2,_,_,3,_,_,_,6,6,1,5,_,0,_,_,_,2,_,_,3,_,_,_,4,4,1,5,_};
const byte track2[] = {_,_,1,_,_,1,_,_,_,1,_,4,4,_,3,_,_,_,1,_,_,1,_,_,_,1,_,2,2,_,3,_};

int main(void)
{
    byte i, j, n;
    PUTS("ostatnie-podrygi/2018-04-29\n");

    P0.skctl = 3;
    P0.audctl = 64 + 32 + 16 + 8;
    i = j = 0;
    for (;;)
    {
        if (j == 0)
        {
            n = track1[i];
            if (!(n & 128))
            {
                note_on(&gen1);
                P0.audf1 = f1[n];
                P0.audf2 = f2[n];
            }
            else
                note_off(&gen1);

            n = track2[i];
            if (!(n & 128))
            {
                note_on(&gen2);
                P0.audf3 = f1[n];
                P0.audf4 = f2[n];
            }
            else
                note_off(&gen2);

            ++i;
            if (i == TRACK_SIZE)
                i = 0;

            j = 6 | (i & 1);
        }

        P0.audc1 = 0x20 | next(&gen1, &env);
        P0.audc3 = 0x20 | next(&gen2, &env);
        --j;
        wait1();
    }
}
