#ifndef POKEY_H_INCLUDED
#define POKEY_H_INCLUDED

typedef unsigned char byte;

struct PokeyIO
{
    union { byte audf1;  const byte pot0; };
    union { byte audc1;  const byte pot1; };
    union { byte audf2;  const byte pot2; };
    union { byte audc2;  const byte pot3; };
    union { byte audf3;  const byte pot4; };
    union { byte audc3;  const byte pot5; };
    union { byte audf4;  const byte pot6; };
    union { byte audc4;  const byte pot7; };
    union { byte audctl; const byte allpot; };
    union { byte stimer; const byte kbcode; };
    union { byte skres;  const byte random; };
    byte potgo;
    byte _;
    union { byte serout; const byte serin; };
    union { byte irqen;  const byte irqst; };
    union { byte skctl;  const byte skstat; };
};

#define P0 (*(volatile struct PokeyIO*)0xd200)
#define P1 (*(volatile struct PokeyIO*)0xd210)
#define P2 (*(volatile struct PokeyIO*)0xd220)
#define P3 (*(volatile struct PokeyIO*)0xd230)

#define STROBE(r) __asm__("sta %w", (unsigned)&r)

#endif

