//cl65 -O -Cl -t atari -Wl -D__SYSTEM_CHECK__=1,-D__RESERVED_MEMORY__=1 seq2.c -o seq2.com
#include <unistd.h>
#include "pokey.h"

#define PUTS(str) write(STDOUT_FILENO, str, sizeof str - 1)

void wait1(void)
{
    __asm__("lda $14");
    __asm__("wait: cmp $14");
    __asm__("beq wait");
}

#define LFO_SIZE 14
typedef struct
{
    byte amp[LFO_SIZE];
    byte i;
} LFO;

byte next(LFO* g)
{
    const byte a = g->amp[g->i];
    ++g->i;
    if (g->i == LFO_SIZE)
        g->i = 0;

    return a;
}

LFO lfo = {{7,5,4,3,2,2,1,5,3,2,2,1,1,0}, 0};

#define SCALE_SIZE 9
//                            C1  Db1  Eb1   F1   G1  Ab1   C2  Db2  Eb2
const byte f2[SCALE_SIZE] = {239, 226, 201, 179, 159, 150, 119, 112, 100};
const byte f4[SCALE_SIZE] = {160, 151, 134, 120, 106, 100,  80,  75,  67};

#define TRACK_SIZE 16
const byte track[TRACK_SIZE] =
{
    3,4,5,2,0,6,7,8,3,4,5,2,0,6,1,2
};

#define D(t) ((t) * 2 * LFO_SIZE)
const byte note_duration[TRACK_SIZE] =
{
    D(4),D(2),D(2),D(3),D(1),D(2),D(1),D(1),D(4),D(2),D(2),D(3),D(1),D(2),D(1),D(1)
};

int main(void)
{
    byte i, j, n;
    PUTS("seq2/2017-11-11\n");

    P0.skctl = 3;
    P0.audctl = 3;
    i = 0;
    j = 0;
    for (;;)
    {
        if (j == 0)
        {
            j = note_duration[i];
            n = track[i];
            P0.audf2 = f2[n];
            P0.audf4 = f4[n];
            STROBE(P0.stimer);

            ++i;
            if (i == TRACK_SIZE)
                i = 0;
        }

        P0.audc2 = 0xa0 | next(&lfo);
        --j;
        wait1();
    }
}
